package kylin.kysdk.java.method;

import kylin.kysdk.java.client.DBusClient;
import lombok.extern.slf4j.Slf4j;
import org.freedesktop.dbus.connections.impl.DBusConnection;
import org.freedesktop.dbus.exceptions.DBusException;
import org.freedesktop.dbus.types.UInt32;
import com.kylin.kysdk.cpuinfo;

@Slf4j
public class CpuMethod implements cpuinfo{
    @Override
    public String getCpuArch(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            cpuinfo obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/cpuinfo", cpuinfo.class);
            return obj.getCpuArch();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public String getCpuVendor(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            cpuinfo obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/cpuinfo", cpuinfo.class);
            return obj.getCpuVendor();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public String getCpuModel(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            cpuinfo obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/cpuinfo", cpuinfo.class);
            return obj.getCpuModel();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public String getCpuFreqMHz(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            cpuinfo obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/cpuinfo", cpuinfo.class);
            return obj.getCpuFreqMHz();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public UInt32 getCpuCorenums(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            cpuinfo obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/cpuinfo", cpuinfo.class);
            return obj.getCpuCorenums();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public String getCpuVirt(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            cpuinfo obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/cpuinfo", cpuinfo.class);
            return obj.getCpuVirt();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public UInt32 getCpuProcess(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            cpuinfo obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/cpuinfo", cpuinfo.class);
            return obj.getCpuProcess();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }

    @Override
    public boolean isRemote() {
        return false;
    }

    @Override
    public String getObjectPath() {
        return null;
    }
}
