package kylin.kysdk.java.method;

import kylin.kysdk.java.client.DBusClient;
import com.kylin.kysdk.netcard;
import lombok.extern.slf4j.Slf4j;
import org.freedesktop.dbus.connections.impl.DBusConnection;
import org.freedesktop.dbus.exceptions.DBusException;

import java.util.List;

@Slf4j
public class NetCardMethod implements netcard {

    @Override
    public List<String> getNetCardName(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardName();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public int getNetCardUp(String nc){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardUp(nc);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return 0;
    }
    @Override
    public List<String> getNetCardUpcards(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardUpcards();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public String getNetCardPhymac(String nc){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardPhymac(nc);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public String getNetCardPrivateIPv4(String nc){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardPrivateIPv4(nc);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public List<String> getNetCardIPv4(String nc){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardIPv4(nc);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public String getNetCardPrivateIPv6(String nc){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardPrivateIPv6(nc);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public List<String> getNetCardIPv6(String nc){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardIPv6(nc);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }

    @Override
    public  int getNetCardType(String nc){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardType(nc);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1;
    }

    @Override
    public  List<String> getNetCardProduct(String nc){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            netcard obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/netcard", netcard.class);
            return obj.getNetCardProduct(nc);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }

    @Override
    public boolean isRemote() {
        return false;
    }

    @Override
    public String getObjectPath() {
        return null;
    }
}
