package kylin.kysdk.java.method;

import kylin.kysdk.java.client.DBusClient;
import com.kylin.kysdk.print;
import lombok.extern.slf4j.Slf4j;
import org.freedesktop.dbus.connections.impl.DBusConnection;
import org.freedesktop.dbus.exceptions.DBusException;

import java.util.List;

@Slf4j
public class PrintMethod implements print {
    @Override
    public List<String> getPrinterList(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            return obj.getPrinterList();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public List<String> getPrinterAvailableList(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            return obj.getPrinterAvailableList();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public void setPrinterOptions(int page,String paperType,String cups,String sided){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            obj.setPrinterOptions(page,paperType,cups,sided);
            return;
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return;
    }
    @Override
    public int getPrinterPrintLocalFile(String printer,String file){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            return obj.getPrinterPrintLocalFile(printer, file);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return 0;
    }
    @Override
    public int getPrinterCancelAllJobs(String printer){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            return obj.getPrinterCancelAllJobs(printer);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return 0;
    }
    @Override
    public int getPrinterStatus(String printer){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            return obj.getPrinterStatus(printer);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return 0;
    }
    @Override
    public String getPrinterFilename(String url){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            return obj.getPrinterFilename(url);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }
    @Override
    public int getPrinterJobStatus(String job, int id){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            return obj.getPrinterJobStatus(job,id);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return 0;
    }
    @Override
    public int getPrinterDownloadRemoteFile(String remoteFile,String localFile){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            print obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/print", print.class);
            return obj.getPrinterDownloadRemoteFile(remoteFile, localFile);
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return 0;
    }

    @Override
    public boolean isRemote() {
        return false;
    }

    @Override
    public String getObjectPath() {
        return null;
    }
}
