package kylin.kysdk.java.method;

import kylin.kysdk.java.client.DBusClient;
import lombok.extern.slf4j.Slf4j;
import org.freedesktop.dbus.connections.impl.DBusConnection;
import org.freedesktop.dbus.exceptions.DBusException;
import com.kylin.kysdk.resource;

@Slf4j
public class ResourceMethod implements resource{
    @Override
    public double getMemTotalKiB(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemTotalKiB();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }
    @Override
    public double getMemUsagePercent(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemUsagePercent();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }
    @Override
    public double getMemUsageKiB(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemUsageKiB();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }
    @Override
    public double getMemAvailableKiB(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemAvailableKiB();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }
    @Override
    public double getMemFreeKiB(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemFreeKiB();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }
    @Override
    public double getMemVirtAllocKiB(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemVirtAllocKiB();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }
    @Override
    public double getMemSwapTotalKiB(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemSwapTotalKiB();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }
    @Override
    public double getMemSwapUsagePercent(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemSwapUsagePercent();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }
    @Override
    public double getMemSwapUsageKiB(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemSwapUsageKiB();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }

    @Override
    public double getMemSwapFreeKiB(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getMemSwapFreeKiB();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;
    }

    @Override
    public double getCpuCurrentUsage(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getCpuCurrentUsage();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return -1.0;

    }

    @Override
    public String getUpTime(){
        DBusConnection conn = null;
        try {
            conn = DBusClient.getConn(DBusConnection.DBusBusType.SYSTEM);
            resource obj = conn.getRemoteObject("com.kylin.kysdk.service",
                    "/com/kylin/kysdk/resource", resource.class);
            return obj.getUpTime();
        } catch (DBusException e) {
            if (conn != null) conn.disconnect();
            log.error("DBusException GetEUser :",e);
        }
        return null;
    }

    @Override
    public boolean isRemote() {
        return false;
    }

    @Override
    public String getObjectPath() {
        return null;
    }
}
