# 系统能力SDK
## 分辨率
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/resolution/

**接口名称：** com.kylin.kysdk.resolution

    Methods：
        1. QStringList getSysLegalResolution(void)
            输出：屏幕，屏幕设置的分辨率，屏幕支持的分辨率

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/resolution/getSysLegalResolution       
            网页返回值：{"Result":0,"ResultMessage":["Arial","Helvetica","Times","Courier"]}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getSysLegalResolution()方法输出的信息

---
## 网络连接
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/netLink/

**接口名称：** com.kylin.kysdk.netLink

    Methods：
        1. unsigned int getNetState(void)
            输出: 网络连接状态

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/netLink/getNetState
            网页返回值：{"Result":0,"ResultMessage":60}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getNetState()方法输出的信息
             

---
## 外设打印
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/print/

**接口名称：** com.kylin.kysdk.print

    Methods：
        1. print - 应用程序打印文档、图片
            in: string
            out: bool
---
## 外设设备枚举
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/peripheralsenum/

**接口名称：** com.kylin.kysdk.peripheralsenum

    Methods：
        1. QStringList getAllUsbInfo(void)
            输出：所有usb设备的名称、类型、PID、VID、序列号、设备节点（若没有对应信息，输出null）

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/peripheralsenum/getAllUsbInfo
            网页返回值：{"Result":0,"ResultMessage":["bing","hausd"]}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getAllUsbInfo()方法输出的信息
---
## 网卡信息
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/netcard/

**接口名称：** com.kylin.kysdk.netcard

    Methods：
        1. QStringList getNetCardName(void)
            输出：所有网卡的名称
        2. int getNetCardType(QString netCardName)
            输入：网卡名称
            输出：网卡类型，有线(0)/无线(1)
        3. QStringList getNetCardProduct(QString netCardName)
            输入：网卡名称
            输出：厂商，型号

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/netcard/getNetCardName
            网页返回值：{"Result":0,"ResultMessage":["sit0"]}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getNetCardName()方法输出的信息

        2. 127.0.0.1:8090/netcard/getNetCardType?netCardName=test
            网页返回值：{"Result":0,"ResultMessage":0}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getNetCardType(QString netCardName)方法输出的信息，URL中“？”之后为参数netCardName，
                           并给netCardName参数赋值为“test”
        
        3. 127.0.0.1:8090/netcard/getNetCardProduct?netCardName=test
            网页返回值：{"Result":0,"ResultMessage":["netCardName","vendor","product"]}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getNetCardProduct(QString netCardName)方法输出的信息，URL中“？”之后为参数netCardName，
                           并给netCardName参数赋值为“test”
---
## BIOS信息
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/bios/

**接口名称：** com.kylin.kysdk.bios

    Methods：
        1. QStringList getBiosVendorVersion(void)
            输出：BIOS厂商，版本号

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/bios/getBiosVendorVersion
            网页返回值：{"Result":0,"ResultMessage":["Vendor: LENOVO","Version: 7VET87WW (3.17 )","Release Date: 07/30/2010","Address: 0xE0000","Runtime Size: 128 kB"]}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getBiosVendorVersion()方法输出的信息

---
## 主板信息
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/mainboard/

**接口名称：** com.kylin.kysdk.mainboard

    Methods：
        1. QString getMainboardName(void)
            输出：主板型号
        2. QString getMainboardDate(void)
            输出：发布日期
        3. QString getMainboardSerial(void)
            输出：主板序列号
        4. QString getMainboardVendor(void)
            输出：主板厂商

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/mainboard/getMainboardName
            网页返回值：{"Result":0,"ResultMessage":"Intel Corporation"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getMainboardName()方法输出的信息

        2. 127.0.0.1:8090/mainboard/getMainboardDate
            网页返回值：{"Result":0,"ResultMessage":"8570 / R7 240/340"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getMainboardDate()方法输出的信息

        3. 127.0.0.1:8090/mainboard/getMainboardSerial
            网页返回值：{"Result":0,"ResultMessage":"AZPM61102417"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getMainboardSerial()方法输出的信息

        4. 127.0.0.1:8090/mainboard/getMainboardVendor
            网页返回值：{"Result":0,"ResultMessage":"DMI type 2, 20 bytes."}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getMainboardVendor()方法输出的信息

---
## 磁盘
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/disk/

**接口名称：** com.kylin.kysdk.disk


    Methods：
        1. QString getDiskType(QString)
            输入：指定磁盘
            输出：磁盘类型，机械(DISK_TYPE_HDD)/固态(DISK_TYPE_SSD)/其他(DISK_TYPE_OTHER)
        2. QString getDiskVersion(QString diskname)
            输入：指定磁盘
            输出：固件版本信息
        3. unsigned int getDiskSpeed(QString diskname)
            输入：指定磁盘
            输出：返回磁盘转速
        4. unsigned long long getDiskSectorNum(QString diskname)
            输入：指定磁盘
            输出：返回磁盘扇区数量

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/disk/getDiskType?diskname=test
            网页返回值：{"Result":0,"ResultMessage":"DISK_TYPE_SSD"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getDiskType(QString diskname)方法输出的信息，URL中“？”之后为参数diskname，
                           并给diskname参数赋值为“test”
        
        2. 127.0.0.1:8090/disk/getDiskVersion?diskname=test
            网页返回值：{"Result":0,"ResultMessage":"CT500MX500SSD1M3CR"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getDiskVersion(QString diskname)方法输出的信息，URL中“？”之后为参数diskname，
                           并给diskname参数赋值为“test”

        3. 127.0.0.1:8090/disk/getDiskSpeed?diskname=test
            网页返回值：{"Result":0,"ResultMessage":"5400"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getDiskSpeed(QString diskname)方法输出的信息，URL中“？”之后为参数diskname，
                           并给diskname参数赋值为“test”
        
        4. 127.0.0.1:8090/disk/getDiskSectorNum?diskname=test
            网页返回值：{"Result":0,"ResultMessage":"12345678900"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getDiskSectorNum(QString diskname)方法输出的信息，URL中“？”之后为参数diskname，
                           并给diskname参数赋值为“test”

---
## 网络
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/net/

**接口名称：** com.kylin.kysdk.net

    Methods：获取端口状态，网关信息，防火墙状态
        1. int getPortState(int port)
            输入：端口号
            输出：端口状态
            （0-FREE， 1-TCP_ESTABLISHED, 2-TCP_SYN_SENT, 3-TCP_SYN_RECV,
            4-TCP_FIN_WAIT1， 5-TCP_FIN_WAIT2， 6-TCP_TIME_WAIT, 7-TCP_CLOSE, 8-TCP_CLOSE_WAIT, 9-TCP_LAST_ACL， 10-TCP_LISTEN, 11-TCP_CLOSING）
        2. QStringList getGatewayInfo(void)
            输出：网关信息-名称，地址
        3. getFirewallState?

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/net/getPortState?port=12345
            网页返回值：{"Result":0,"ResultMessage":6}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getPortState(int port)方法输出的信息，URL中“？”之后为参数port，
                           并给port参数赋值为12345
        
        2. 127.0.0.1:8090/net/getGatewayInfo
            网页返回值：{"Result":0,"ResultMessage":["WIFI","Address"]}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getGatewayInfo)方法输出的信息

---
## 运行时信息
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/runinfo/

**接口名称：** com.kylin.kysdk.runinfo

    Methods：
        1. double getIoSpeed(void)
            输出：实时IO读写速率
        2. double getNetSpeed(void)
            输出：实时网速
        3. double getMainboardTemperature(void)
            输出：实时主板温度?
        4. double getCpuTemperature(void)
            输出：实时CPU温度
        5. double getDiskTemperature(QString diskpath)
            输入：硬盘绝对路径
            输出：实时硬盘温度

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/runinfo/getIoSpeed
            网页返回值：{"Result":0,"ResultMessage":0}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getIoSpeed()方法输出的信息
        
        2. 127.0.0.1:8090/runinfo/getNetSpeed
            网页返回值：{"Result":0,"ResultMessage":0}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getNetSpeed()方法输出的信息

        3. 127.0.0.1:8090/runinfo/getMainboardTemperature
            网页返回值：{"Result":0,"ResultMessage":0}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getMainboardTemperature()方法输出的信息

        4. 127.0.0.1:8090/runinfo/getCpuTemperature
            网页返回值：{"Result":0,"ResultMessage":67}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getCpuTemperature()方法输出的信息

        5. 127.0.0.1:8090/runinfo/getDiskTemperature?diskpath=test
            网页返回值：{"Result":0,"ResultMessage":-1}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getDiskTemperature(QString diskpath)方法输出的信息，URL中“？”之后为参数diskpath，
                           并给diskpath参数赋值为"test"

---
## 地理位置
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/gps/

**接口名称：** com.kylin.kysdk.gps

    Methods：
        1. QString getGPSInfo(void)
            输出：国家城市经纬度

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/gps/getGPSInfo
            网页返回值：{"Result":0,"ResultMessage":"117:10E,39:10N"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getGPSInfo()方法输出的信息

---
## 进程信息
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/process/

**接口名称：** com.kylin.kysdk.process

    Methods：
        1. double getProcInfoCpuUsage(int pid)
            输入：进程号
            输出：CPU瞬时使用率
        2. double getProcInfoIoUsage(int pid)
            输入：进程号
            输出：IO使用率
        3. double getProcInfoMemUsage(int pid)
            输入：进程号
            输出：内存占用率
        4. QString getProcInfoStatus(int pid)
            输入：进程号
            输出：进程状态
        5. int getProcInfoPort(int pid)
            输入：进程号
            输出：进程使用的端口号
        6. QString getProcInfoStartTime(int pid)
            输入：进程号
            输出：进程的启动时间
        7. QString getProcInfoRunningTime(int pid)
            输入：进程号
            输出：进程的运行时间
        8. QString getProcInfoCpuTime(int pid)
            输入：进程号
            输出：CPU时间
        9. QString getProcInfoCmd(int pid)
            输入：进程号
            输出：cmd
        10. QString getProcInfoUser(int pid)
            输入：进程号
            输出：属主
        11. QStringList getProcInfo(QString  processname)
            输入：进程名
            输出：某进程所有信息

**JS接口：**  
    URL：
        1. 127.0.0.1:8090/process/getProcInfoCpuUsage?pid=3009
            网页返回值：{"Result":0,"ResultMessage":0}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoCpuUsage(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009
        2. 127.0.0.1:8090/process/getProcInfoIoUsage?pid=3009
            网页返回值：{"Result":0,"ResultMessage":0}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoIoUsage(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009

        3. 127.0.0.1:8090/process/getProcInfoMemUsage?pid=3009
            网页返回值：{"Result":0,"ResultMessage":0}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoMemUsage(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009

        4. 127.0.0.1:8090/process/getProcInfoStatus?pid=3009
            网页返回值：{"Result":0,"ResultMessage":"0"}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoStatus(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009
        
        5. 127.0.0.1:8090/process/getProcInfoPort?pid=3009
            网页返回值：{"Result":0,"ResultMessage":0}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoPort(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009

        6. 127.0.0.1:8090/process/getProcInfoStartTime?pid=3009
            网页返回值：{"Result":0,"ResultMessage":""}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoStartTime(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009
        
        7. 127.0.0.1:8090/process/getProcInfoRunningTime?pid=3009
            网页返回值：{"Result":0,"ResultMessage":""}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoRunningTime(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009

        8. 127.0.0.1:8090/process/getProcInfoCpuTime?pid=3009
            网页返回值：{"Result":0,"ResultMessage":""}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoCpuTime(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009

        9. 127.0.0.1:8090/process/getProcInfoCmd?pid=3009
            网页返回值：{"Result":0,"ResultMessage":""}
            Result：连接dbus服务是否成功，0 成功，-1失败
            ResultMessage：调用getProcInfoCmd(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009

        10. 127.0.0.1:8090/process/getProcInfoUser?pid=3009
             网页返回值：{"Result":0,"ResultMessage":""}
             Result：连接dbus服务是否成功，0 成功，-1失败
             ResultMessage：调用getProcInfoUser(int pid)方法输出的信息,URL中“？”之后为参数pid，
                           并给pid参数赋值为3009
        
        11. 127.0.0.1:8090/process/getProcInfo?processname=bash
             网页返回值：{"Result":0,"ResultMessage":[]}
             Result：连接dbus服务是否成功，0 成功，-1失败
             ResultMessage：调用getProcInfo(QString  processname)方法输出的信息,URL中“？”之后为参数processname，
                           并给pid参数赋值为"bash"

---
## 依赖关系调整
**服务名称：** com.kylin.kysdk.service

**路径名称：** /com/kylin/kysdk/dependence/

**接口名称：** com.kylin.kysdk.dependence

    Methods：
        1. rmDependence - 移除对任何kylin特性应用的依赖
            in: null
            out: bool
---